// 003 u_ib_script
// 22 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_ib_script;
  interface
    uses Classes, u_c_basic_object
        , u_types_constants
        ;

    procedure remove_ib_script_comments(p_c_stringlist: tStrings);

  implementation
    uses SysUtils, Dialogs, u_c_display;

    procedure remove_ib_script_comments(p_c_stringlist: tStrings);
        // -- remove "___// xxx"
        // -- remove "|__(* xxxx"     "| ___*)"
        // -- remove empty lines
        // -- remove |__/* ... */  or   "|__/* xxx"        "| xxx  */ yyy
      var l_line_index: Integer;
          l_the_line, l_trimmed_line: String;

      procedure delete_slash_star_comment;
        // var l_index: Integer;
        begin
(*
          // -- only remove if */ on same line
          Delete(l_line_index);
          while l_line_index< Count do
          begin
            l_the_line:= Strings[l_line_index];
            l_trimmed_line:= Trim(l_the_line);
            if (Length(l_trimmed_line)> 1)
                and (l_trimmed_line[1]= '*')
                and (l_trimmed_line[2]= '/')
              then begin
                  Delete(l_line_index);
                  Break;
                end
              else Delete(l_line_index)
          end; // while l_line_index
*)
        end; // delete_slash_star_comment

      begin // remove_comments
        with p_c_stringlist do
        begin
          l_line_index:= 0;

          while l_line_index< Count do
          begin
            l_the_line:= Strings[l_line_index];

            l_trimmed_line:= Trim(l_the_line);

            if l_trimmed_line= ''
              then Delete(l_line_index) else

            if (Length(l_trimmed_line)> 1)
                and (l_trimmed_line[1]= '/')
                and (l_trimmed_line[2]= '/')
              then Delete(l_line_index) else

            if (Length(l_trimmed_line)> 1)
               and (l_trimmed_line[1]= '(')
               and (l_trimmed_line[2]= '*')
              then begin
                  Delete(l_line_index);
                  while l_line_index< Count do
                  begin
                    l_the_line:= Strings[l_line_index];
                    l_trimmed_line:= Trim(l_the_line);
                    if (Length(l_trimmed_line)> 1)
                        and (l_trimmed_line[1]= '*')
                        and (l_trimmed_line[2]= ')')
                      then begin
                          Delete(l_line_index);
                          Break;
                        end
                      else Delete(l_line_index)
                  end; // while l_line_index
                end else
            if (Length(l_trimmed_line)> 3)
               and (l_trimmed_line[1]= '/')
               and (l_trimmed_line[2]= '*')
               and (l_trimmed_line[Length(l_trimmed_line)- 1]= '*')
               and (l_trimmed_line[Length(l_trimmed_line)]= '/')
              then // delete slash_star_comment
                   Delete(l_line_index)
            else Inc(l_line_index);
          end; // while
        end; // with p_c_stringlist
      end; // remove_ib_script_comments

    begin // u_c_ib_script
    end. // u_c_ib_script



