// 002 u_script_executer_with_blobs
// 16 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_script_executer_with_blobs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, IBDatabase, DB, IBSQL, IBExtract,
  IBCustomDataSet, IBQuery, Grids, DBGrids, DBCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    dir_: TTabSheet;
    insert_: TTabSheet;
    exit_: TButton;
    clear_: TButton;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBSQL1: TIBSQL;
    PageControl2: TPageControl;
    display_: TTabSheet;
    script__: TTabSheet;
    Memo1: TMemo;
    Panel3: TPanel;
    script_memo_: TMemo;
    IBQuery1: TIBQuery;
    base_directory_listbox_: TDirectoryListBox;
    base_file_listbox_: TFileListBox;
    Panel5: TPanel;
    exec_: TCheckBox;
    insert_blob_data_: TButton;
    param_trial_: TButton;
    param_ibquery_: TButton;
    display_blob_: TButton;
    empty_table_: TButton;
    script_directory_listbox_: TDirectoryListBox;
    script_file_listbox_: TFileListBox;
    original_script_: TTabSheet;
    original_memo_: TMemo;
    table_name_edit_: TEdit;
    DataSource1: TDataSource;
    dbgrid_: TTabSheet;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    open_: TButton;
    DBMemo2: TDBMemo;
    DBMemo3: TDBMemo;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    IBQuery2: TIBQuery;
    non_html_: TTabSheet;
    non_html_memo_: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure insert_blob_data_Click(Sender: TObject);
    procedure param_trial_Click(Sender: TObject);
    procedure param_ibquery_Click(Sender: TObject);
    procedure display_blob_Click(Sender: TObject);
    procedure empty_table_Click(Sender: TObject);
    procedure base_file_listbox_Click(Sender: TObject);
    procedure script_directory_listbox_Change(Sender: TObject);
    procedure script_file_listbox_Click(Sender: TObject);
    procedure base_directory_listbox_Change(Sender: TObject);
    procedure table_name_edit_Change(Sender: TObject);
    procedure open_Click(Sender: TObject);
    procedure DBMemo1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_file, u_dir
        , u_c_ini_file
        , u_strings
        , u_ibx
        , u_c_insert_ib_blob
        , u_c_field_value_list
        ;

    {$R *.DFM}

    const k_initial_path= 'c:\prog\uti_del\shell\';
            k_file_name= 'e.ed';
            k_extension= '.*';
    const k_table_name= 'Portal_HtmlText';

          // -- ini keys
          k_save_path= k_initial_path;
          k_save_name= k_file_name;

          k_load_base_path_ini_key=      'load_base_path';
          k_load_base_file_name_ini_key= 'load_base_file_name';
          k_load_script_path_ini_key=      'load_script_path';
          k_load_script_file_name_ini_key= 'load_script_file_name';
          k_load_script_table_name_ini_key= 'load_script_table_name';

          k_root_path= 'c:\prog\essais_util\web\_starter_kit\';
          k_database_path= k_root_path+ '__data\';
            k_database_name= 'asp_net_portal.gdb';

          k_script_path= k_root_path+ '__data\schema\';
          k_script_insert_into_path= 'data\';

    var g_script_path: String= k_initial_path;
        g_script_file_name: String= k_file_name;

        g_base_path: String= k_initial_path;
        g_base_file_name: String= k_file_name;

        g_table_name: String= k_table_name;

        g_c_ini_file: c_ini_file= Nil;

    procedure handle_file(p_path, p_file_name: String);
      begin
        display(p_file_name);
      end; // handle_file

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      var l_index_of_script: Integer;
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('create_base');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_base_path:= f_initialize_parameter(k_load_base_path_ini_key, k_save_path);
          display(g_base_path);
          g_base_file_name:= f_initialize_parameter(k_load_base_file_name_ini_key, k_save_name);

          g_script_path:= f_initialize_parameter(k_load_script_path_ini_key, k_save_path);
          g_script_file_name:= f_initialize_parameter(k_load_script_file_name_ini_key, k_save_name);

          g_table_name:=  f_initialize_parameter(k_load_script_table_name_ini_key, k_table_name);
        end;

        set_directory_listbox_directory(base_directory_listbox_, g_base_path);
        set_directory_listbox_directory(script_directory_listbox_, g_script_path);
        script_file_listbox_.Mask:= '*'+ k_extension;

        // display(g_script_file_name);
        with script_file_listbox_, Items do
        begin
          l_index_of_script:= IndexOf(g_script_file_name);
          // display(IntToStr(l_index_of_script));
          If l_index_of_script>= 0
            then ItemIndex:= l_index_of_script;
        end;
        with base_file_listbox_, Items do
        begin
          l_index_of_script:= IndexOf(g_base_file_name);
          // display(IntToStr(l_index_of_script));
          If l_index_of_script>= 0
            then ItemIndex:= l_index_of_script;
        end;

        table_name_edit_.Text:= g_table_name;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.base_directory_listbox_Change(Sender: TObject);
      begin
        with base_directory_listbox_ do
          g_base_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_base_path_ini_key, g_base_path);
      end; // base_directory_listbox_Change

    procedure TForm1.base_file_listbox_Click(Sender: TObject);
        // -- the file clicked in the bottom list_box

      procedure initialise_ib_database;
        begin
          with Form1.IbDatabase1 do
          begin
            if Connected
              then Close;
            DataBaseName:= g_base_path+ g_base_file_name;
            Params.Clear;
            Params.Add('user_name=SYSDBA');
            Params.Add('password=masterkey');
            Open;
          end; // with Form1.IbDatabase1
        end; // initialise_ib_databae

      begin // base_file_listbox_
        with base_file_listbox_ do
          g_base_file_name:= Items[ItemIndex];
        initialise_ib_database;
        g_c_ini_file.set_parameter(k_load_base_file_name_ini_key, g_base_file_name);
      end; // base_file_listbox_

    procedure TForm1.script_directory_listbox_change(Sender: TObject);
      begin
        with script_directory_listbox_ do
          g_script_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_script_path_ini_key, g_script_path);
      end; // script_directory_listbox_change

    procedure TForm1.script_file_listbox_Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      begin
        with script_file_listbox_ do
          g_script_file_name:= Items[ItemIndex];
        display(g_script_path+ ' '+ g_script_file_name);
        g_c_ini_file.set_parameter(k_load_script_file_name_ini_key, g_script_file_name);

        handle_file(g_script_path, g_script_file_name);

        original_memo_.Lines.LoadFromFile(g_script_path+ g_script_file_name);

        display_line;
        display('finished');
      end; // script_file_listbox_Click

    procedure TForm1.table_name_edit_Change(Sender: TObject);
      begin
        g_table_name:= table_name_edit_.Text;
        g_c_ini_file.set_parameter(k_load_script_table_name_ini_key, g_table_name);
      end; // table_name_edit_Change

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    procedure remove_comments(p_c_stringlist: tStrings);
        // -- remove "___// xxx"
        // -- remove "|__(* xxxx"     "| ___*)"
        // -- remove empty lines
        // -- remove |__/* ... */  or   "|__/* xxx"        "| xxx  */ yyy
      var l_line_index: Integer;
          l_the_line, l_trimmed_line: String;

      procedure delete_slash_star_comment;
        // var l_index: Integer;
        begin
(*
          // -- only remove if */ on same line
          Delete(l_line_index);
          while l_line_index< Count do
          begin
            l_the_line:= Strings[l_line_index];
            l_trimmed_line:= Trim(l_the_line);
            if (Length(l_trimmed_line)> 1)
                and (l_trimmed_line[1]= '*')
                and (l_trimmed_line[2]= '/')
              then begin
                  Delete(l_line_index);
                  Break;
                end
              else Delete(l_line_index)
          end; // while l_line_index
*)
        end; // delete_slash_star_comment

      begin // remove_comments
        with p_c_stringlist do
        begin
          l_line_index:= 0;

          while l_line_index< Count do
          begin
            l_the_line:= Strings[l_line_index];

            l_trimmed_line:= Trim(l_the_line);

            if l_trimmed_line= ''
              then Delete(l_line_index) else

            if (Length(l_trimmed_line)> 1)
                and (l_trimmed_line[1]= '/')
                and (l_trimmed_line[2]= '/')
              then Delete(l_line_index) else

            if (Length(l_trimmed_line)> 1)
               and (l_trimmed_line[1]= '(')
               and (l_trimmed_line[2]= '*')
              then begin
                  Delete(l_line_index);
                  while l_line_index< Count do
                  begin
                    l_the_line:= Strings[l_line_index];
                    l_trimmed_line:= Trim(l_the_line);
                    if (Length(l_trimmed_line)> 1)
                        and (l_trimmed_line[1]= '*')
                        and (l_trimmed_line[2]= ')')
                      then begin
                          Delete(l_line_index);
                          Break;
                        end
                      else Delete(l_line_index)
                  end; // while l_line_index
                end else
            if (Length(l_trimmed_line)> 3)
               and (l_trimmed_line[1]= '/')
               and (l_trimmed_line[2]= '*')
               and (l_trimmed_line[Length(l_trimmed_line)- 1]= '*')
               and (l_trimmed_line[Length(l_trimmed_line)]= '/')
              then // delete slash_star_comment
                   Delete(l_line_index)
            else Inc(l_line_index);
          end; // while
        end; // with p_c_stringlist
      end; // remove_comments

    // -- INSERT INTO

    var g_c_field_value_list: c_field_value_list= Nil;

    procedure TForm1.insert_blob_data_Click(Sender: TObject);
        // -- slice the script into individual requests, and send to creation
      var l_c_insert_ib_blob: c_insert_ib_blob;
          l_c_result_list: tStringList;

      procedure create_field_value_list;
        var l_field_index: Integer;
            l_c_field_value: c_field_value;
        begin
          display('> create_field_value_list');

          with IbQuery1, Sql do
          begin
            Close;
            Clear;
            Add('SELECT * FROM '+ k_table_name);
            Open;
            for l_field_index:= 0 to FieldCOunt- 1 do
              with FieldDefs[l_field_index] do
              begin
                l_c_field_value:= g_c_field_value_list.f_c_add_field_value(Name, DataType, '', Nil);
                if Name= ''
                  then display_bug_stop('no_name');
                // -- already create the strem for the blob data
                case DataType of
                  ftBlob : begin
                      display('blob');
                      l_c_field_value.m_c_stream:= tMemoryStream.Create;
                    end;
                  ftMemo : begin
                      display('memo '+ Name);
                      // stop('memo_field');
                      l_c_field_value.m_c_stream:= tMemoryStream.Create;
                    end;
                  ftGraphic : ;
                 end; // case
              end; // for l_field_index, with FieldDefs

            Close;
            IbDatabase1.Close;
          end; // with IbQuery1, Sql

          display('< create_field_value_list');
        end; // create_field_value_list

      procedure do_create;
        begin
          if Assigned(l_c_insert_ib_blob)
            then begin
                display_line;

                l_c_insert_ib_blob.insert_into_blob(g_c_field_value_list);
                l_c_result_list.Add(l_c_insert_ib_blob.m_explain);
                l_c_insert_ib_blob.Free;
              end;
        end; // do_create

      var l_c_script: tStringList;
          l_line_index: Integer;
          l_line, l_trimmed_line: String;
          l_table_index: Integer;

      begin // insert_blob_data_Click
        display('> insert_blob_data_Click');

        IbDatabase1.Close;
        // -- open the base
        f_open_ib_database('open_database', Form1.IbDatabase1);
        Caption:= IbDatabase1.DatabaseName;
        g_c_field_value_list:= c_field_value_list.create_field_value_list('field_values');
        create_field_value_list;

        display('script '+ g_script_path+ g_script_file_name);
        script_memo_.Lines.LoadFromFile(g_script_path+ g_script_file_name);

        l_c_result_list:= tStringList.Create;

        l_c_script:= tStringList.Create;
        with l_c_script do
        begin
          LoadFromFile(g_script_path+ g_script_file_name);

          remove_comments(l_c_script);
          // display_strings_only(l_c_script);

          l_c_insert_ib_blob:= Nil;
          l_table_index:= 0;

          for l_line_index:= 0 to Count- 1 do
          begin
            l_line:= Strings[l_line_index];
            // display(''+ l_line);
            l_trimmed_line:= Trim(l_line);

            if l_trimmed_line<> ''
              then begin
                  // -- no indentation: the start of a new script
                  if (Length(l_line)> 0) and (l_line[1]<> ' ')
                    then begin
                        do_create;
                        Inc(l_table_index);

                        l_c_insert_ib_blob:= c_insert_ib_blob.create_insert_ib_blob('', l_line, IbSql1);
                        l_c_insert_ib_blob.m_exec_sql:= exec_.Checked;
                        l_c_insert_ib_blob.m_c_request.Add(l_line);
                      end
                    else begin
                        // display('add >'+ l_trimmed_line+ '<');
                        // l_c_insert_ib_blob.m_c_request.Add(l_trimmed_line);
                        l_c_insert_ib_blob.m_c_request.Add(l_line);
                      end;
                end;

(*
            if l_table_index> 2
              then Exit;
*)
          end; // for l_line_index

          // -- the last, if any
          do_create;

          Free;
        end; // with tStringList

        display_line;
        display('result: ');
        display_strings(l_c_result_list);
        l_c_result_list.Free;

        FreeAndNil(g_c_field_value_list);
        display('< insert_blob_data_Click');
      end; // insert_blob_data_Click

   var g_request_count: Integer= 140;

    procedure TForm1.param_trial_Click(Sender: TObject);
      var p_request: String;
          l_with_parameter: Boolean;
      begin
        with IbSql1 do
        begin
          try
            display('exec');
            f_open_ib_database('open_ib_db', DataBase);
            if DataBase.DefaultTransaction.InTransaction
              then DataBase.DefaultTransaction.Commit;
            DataBase.DefaultTransaction.StartTransaction;

            l_with_parameter:= False;
            // -- nok on Prepare
            p_request:= 'INSERT INTO PORTAL_HTMLTEXT (MODULEID) '
                + ' VALUES (:MODULEID)';
            // -- OK
            p_request:= 'INSERT INTO Portal_HtmlText (ModuleID) '
                + ' VALUES ('+ IntToStr(100+ g_request_count)+ ')';
            // -- nok on Prepare

            l_with_parameter:= True;
            p_request:= 'INSERT INTO Portal_HtmlText (ModuleID) '
                + ' VALUES ( :ModuleId )';
            p_request:= 'INSERT INTO Portal_HtmlText (MODULEID) '
                + ' VALUES ( :x)';
            p_request:= 'INSERT INTO PORTAL_HTMLTEXT (ModuleID) '
                + ' VALUES ( :x)';

            Close;
            GenerateParamNames:= true;
            ParamCheck:= false;
            SQL.Text:= p_request;
            display('req '+ p_request+ '|');
            // -- NOK INSERT INTO PORTAL_HTMLTEXT (MODULEID)  VALUES (:MODULEID)|

            display('prepare');
            Prepare();

            display('fill params');
            if l_with_parameter
              then Params[0].AsInteger:= 120 + g_request_count;
            Inc(g_request_count);

            display('ExecQuery');
            ExecQuery;
            DataBase.DefaultTransaction.Commit;

          except
            on e: Exception do
              begin
                display(e.Message);
              end;
          end; // try except
        end; // with m_c_ib_sql_ref
      end; // param_trial_Click

    procedure TForm1.param_ibquery_Click(Sender: TObject);
      var p_request: String;
          l_with_parameter: Boolean;
      begin
(*
        with IbQuery1 do
        begin
          try
            display('exec');
            f_open_ib_database('open_ib_db', DataBase);
            if DataBase.DefaultTransaction.InTransaction
              then DataBase.DefaultTransaction.Commit;
            DataBase.DefaultTransaction.StartTransaction;

            l_with_parameter:= False;
            // -- nok on Prepare
            p_request:= 'INSERT INTO PORTAL_HTMLTEXT (MODULEID) '
                + ' VALUES (:MODULEID)';
            // -- OK
            p_request:= 'INSERT INTO Portal_HtmlText (ModuleID) '
                + ' VALUES ('+ IntToStr(100+ g_request_count)+ ')';
            // -- nok on Prepare

            l_with_parameter:= True;
            p_request:= 'INSERT INTO Portal_HtmlText (ModuleID) '
                + ' VALUES ( :ModuleId )';
            p_request:= 'INSERT INTO Portal_HtmlText (MODULEID) '
                + ' VALUES ( :x)';
            p_request:= 'INSERT INTO PORTAL_HTMLTEXT (ModuleID) '
                + ' VALUES ( :x)';
            // ok
            p_request:= 'INSERT INTO PORTAL_HTMLTEXT (MODULEID) '
                + ' VALUES (:x)';
            p_request:= 'INSERT INTO Portal_HtmlText (ModuleID) '
                + ' VALUES ( :ModuleId )';

            Close;
            GenerateParamNames:= true;
            // ParamCheck:= false;
            SQL.Text:= p_request;
            display('req '+ p_request+ '|');
            // -- NOK INSERT INTO PORTAL_HTMLTEXT (MODULEID)  VALUES (:MODULEID)|

            display('prepare');
            Prepare();

            display('fill params');
            if l_with_parameter
              then Params[0].AsInteger:= 120 + g_request_count;
            Inc(g_request_count);

            display('ExecQuery');
            ExecSql;
            DataBase.DefaultTransaction.Commit;

          except
            on e: Exception do
              begin
                display(e.Message);
              end;
          end; // try except
        end; // with m_c_ib_sql_ref
*)
      end; // param_ibquery_Click

    procedure TForm1.display_blob_Click(Sender: TObject);
        // -- display the start of the blobs in a Memo
      var l_c_memory_stream: tMemoryStream;
          l_index: Integer;
          l_byte: Byte;
          l_display_string: String;
          l_row_count: Integer;
      begin
        PageControl2.ActivePage:= display_;
        
        display('> display_blob_click');
        with Form1, IbQuery1, Sql do
        begin
          Database.Close;
          f_open_ib_database('open_ib_db', DataBase);
          Caption:= Database.DatabaseName;
          Close;
          Clear;
          Add('SELECT * FROM PORTAL_HTMLTEXT');
          // Add('  WHERE MODULEID= 2');
          Open;

          l_row_count:= 0;
          while not Eof do
          begin
            l_c_memory_stream:= tMemoryStream.Create;

            // display('Stream.Position: '+ IntToStr(l_c_memory_stream.Position));
            // display('Stream_size: '+ IntToStr(l_c_memory_stream.Size));
            (FieldByName('DesktopHtml') as tBlobField).SaveToStream(l_c_memory_stream);
            // display_strings(Form1.Query1.Sql);
            // display('Stream.Position: '+ IntToStr(l_c_memory_stream.Position));
            l_c_memory_stream.Position:= 0;
            l_display_string:= '';
            for l_index:= 0 to 51 do
            begin
              l_c_memory_stream.Read(l_byte, 1);
              // display(IntToStr(l_byte)+ ' '+ Chr(l_byte));
              l_display_string:= l_display_string+ Chr(l_byte);
            end;
            display(IntToStr(l_row_count)+ ' '+ l_display_string);

            Next;
            Inc(l_row_count);
          end; // while
        end; // with Query1, Sql
        display('< display_blob_click '+ IntToStr(l_row_count)+ ' rows');
      end; // display_blob_Click

    procedure TForm1.empty_table_Click(Sender: TObject);
      begin
(*
        display('> empty_table');
        with Form1, IbQuery1, Sql do
        begin
          Close;
          Clear;
          Add('DELETE FROM PORTAL_HTMLTEXT');
          // Add('  WHERE MODULEID= 2');
          ExecSql;
        end; // with Query1, Sql
        display('< empty_table');
*)
      end; // empty_table_Click

    procedure TForm1.open_Click(Sender: TObject);
        // -- display the blob in the dBMemo
      begin
        display('> open_table');
        with Form1, IbQuery2, Sql do
        begin
          Database.Close;
          f_open_ib_database('open_ib_db', DataBase);
          Caption:= Database.DatabaseName;
          Close;
          Clear;
          Add('SELECT * FROM '+ g_table_name);
          // Add('  WHERE MODULEID= 2');
          Open;
          dbMemo1.DataField:= 'DesktopHtml';
          dbMemo2.DataField:= 'MobileSummary';
          dbMemo3.DataField:= 'MobileDetails';
        end; // with Query1, Sql
        display('< open_table');
      end; // open_Click

    procedure TForm1.DBMemo1Click(Sender: TObject);
        // -- remove the &nbsp coding
      begin
        display_line;
        display('> replace');
        non_html_memo_.Lines.Text:= f_remove_ampersand_string(dbMemo1.Lines.Text);
        display('< replace');
      end; // DBMemo1Click

end.


